﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JSONDotNET
{
    /// <summary>
    /// Tiebreaking rules:
    ///  -- A list is better than an array
    /// </summary>
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field, Inherited = false, AllowMultiple = true)]
    public sealed class TypeHintAttribute : Attribute
    {
        readonly Type _hint;

        // This is a positional argument
        public TypeHintAttribute(Type potentialType)
        {
            this._hint = potentialType;
        }

        public Type PotentialType
        {
            get { return _hint; }
        }
    }
}
