﻿//(c) Alexandru Ghiondea, 2011
using System;

namespace TestLibrary
{
    [AttributeUsage(AttributeTargets.Method, Inherited = false, AllowMultiple = false)]
    public sealed class TestCaseAttribute : Attribute
    {
        private string myTestName;
        private TestcaseType myExpectedResult;

        public TestCaseAttribute(string testName, TestcaseType expectedResult = TestcaseType.Positive)
        {
            this.myTestName = testName;
            this.myExpectedResult = expectedResult;
        }

        public string TestName
        {
            get { return myTestName; }
        }

        public TestcaseType ExpectedResult
        {
            get { return myExpectedResult; }
        }

    }

}
